package com.sunwin.robot2ips.util;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;

import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSession;
import javax.net.ssl.SSLSessionContext;

public class HttpsUtils {
    /**
     * 发送HTTPS请求
     * @param toURL 请求地址
     * @param data 请求参数
     * @param dateType 参数类型，“JSON”,other
     * @return
     * @throws Exception
     */
    public static String HttpsPostUtil(String toURL, String data,String dateType)
            throws Exception {
        StringBuffer bs = new StringBuffer();

        //  直接通过主机认证
        HostnameVerifier hv = new HostnameVerifier() {
            @Override
            public boolean verify(String arg0, SSLSession arg1) {
                return true;
            }
        };
        //  配置认证管理器
        javax.net.ssl.TrustManager[] trustAllCerts = {new TrustAllTrustManager()};
        SSLContext sc = SSLContext.getInstance("SSL");
        SSLSessionContext sslsc = sc.getServerSessionContext();
        sslsc.setSessionTimeout(0);
        sc.init(null, trustAllCerts, null);
        HttpsURLConnection.setDefaultSSLSocketFactory(sc.getSocketFactory());
        //  激活主机认证
        HttpsURLConnection.setDefaultHostnameVerifier(hv);
        URL url = new URL(toURL);
        HttpURLConnection connection = (HttpURLConnection)url.openConnection();
        connection.setConnectTimeout(30000);
        connection.setReadTimeout(30000);
        connection.setDoOutput(true);
        if("JSON".equalsIgnoreCase(dateType)){
            connection.setRequestProperty("Content-Type","application/json;chert=UTF-8");
        }else{
            connection.setRequestProperty("Content-Type","application/x-www-form-urlencoded");
        }
        OutputStreamWriter out = new OutputStreamWriter(
                connection.getOutputStream(), "UTF-8");
        out.write(data);
        out.flush();
        out.close();
        connection.connect();
        int code = ((HttpURLConnection) connection).getResponseCode();
        InputStream is =  null;
        if (code == 200) {
            is = connection.getInputStream(); // 得到网络返回的正确输入流
        } else {
            is = ((HttpURLConnection) connection).getErrorStream(); // 得到网络返回的错误输入流
        }
        BufferedReader buffer = new BufferedReader(new InputStreamReader(is,"UTF-8"));

        String l = null;
        while ((l = buffer.readLine()) != null) {
            bs.append(l);
        }
        //return bs.toString();
        return String.valueOf(bs);
    }
}